﻿
Enumeration
  #CLSCTX_INPROC_SERVER  = 1
  #CLSCTX_INPROC_HANDLER = 2
  #CLSCTX_LOCAL_SERVER   = 4
  #CLSCTX_REMOTE_SERVER  = 16
  #CLSCTX_SERVER = (#CLSCTX_INPROC_SERVER | #CLSCTX_LOCAL_SERVER | #CLSCTX_REMOTE_SERVER)
EndEnumeration

Structure TYPEATTR
  guid.GUID
  lcid.l
  dwReserved.l
  memidConstructor.l
  memidDestructor.l
  lpstrSchema.l
  cbSizeInstance.l
  typekind.l
  cFuncs.w
  cVars.w
  cImplTypes.w
  cbSizeVft.w
  cbAlignment.w
  wTypeFlags.w
  wMajorVerNum.w
  wMinorVerNum.w
  tdescAlias.l
  idldescType.l
EndStructure

ProcedureDLL.l CreateObject(ProgID.s) ; Creates COM object from ProgID
  Protected ProgID_Unicode.s = Space(Len(ProgID) * 2)
  Protected err.l, lcid.l, aTypeAttributes.l, IID_OBJECT.l, object.l
  Protected CLSID.GUID
  Protected oDispatch.IDispatch
  Protected oDispTypeInfo.ITypeInfo
  Protected *oTypeAttributes.TYPEATTR

  PokeS(@ProgID_Unicode, ProgID, #PB_Any, #PB_Unicode)

  err.l = CLSIDFromProgID_(@ProgID_Unicode, @CLSID.GUID)
  If err <> #S_OK
    SetErrorNumber(err)
    ProcedureReturn #False
  EndIf

  err.l = CoCreateInstance_(CLSID,0,#CLSCTX_SERVER,?IID_IDispatch,@oDispatch.IDispatch)
  If err <> #S_OK
    SetErrorNumber(err)
    ProcedureReturn #False
  EndIf

  If oDispatch\GetTypeInfo(0,lcid,@oDispTypeInfo.ITypeInfo) = #S_OK
    If oDispTypeInfo\GetTypeAttr(@aTypeAttributes.l) = #S_OK
      *oTypeAttributes.TYPEATTR=aTypeAttributes
      IID_OBJECT = *oTypeAttributes\guid
      oDispTypeInfo\ReleaseTypeAttr(aTypeAttributes)
    EndIf
    oDispTypeInfo\Release()
  EndIf

  err.l = oDispatch\QueryInterface(IID_OBJECT,@object.l)
  If err <> #S_OK
    oDispatch\Release()
    SetErrorNumber(err)
    ProcedureReturn #False
  EndIf
  oDispatch\Release()

  ProcedureReturn object
EndProcedure

ProcedureDLL.l CreateObject_Unicode(ProgID.s)
  Protected ProgID2.s = PeekS(@ProgID, #PB_Any, #PB_Unicode)
  ProgID = ProgID2
  ProcedureReturn CreateObject(ProgID)
EndProcedure

ProcedureDLL ReleaseObject(*object.IUnknown) ; Releases Object from memory
  If *object
    *object\Release()
  EndIf
EndProcedure

ProcedureDLL COMLIB_PB4_Init()
  CoInitialize_(#Null)
EndProcedure

ProcedureDLL COMLIB_PB4_End()
  CoUninitialize_()
EndProcedure

DataSection
  IID_IDispatch:
  Data.l $00020400
  Data.w $0000, $0000
  Data.b $C0,$00,$00,$00,$00,$00,$00,$46
EndDataSection

DataSection
  IID_IUnknown:
  Data.l $00000000
  Data.w $0000, $0000
  Data.b $C0,$00,$00,$00,$00,$00,$00,$46
EndDataSection

; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 80
; FirstLine = 51
; Folding = --
; EnableXP
; HideErrorLog