﻿CompilerIf Defined(IFileSystem,#PB_Interface) = #False
Interface IFileSystem Extends IDispatch
  get_Drives(dispidMember.l)
  BuildPath(Path.p-bstr,Name.p-bstr,dispidMember.l)
  GetDriveName(Path.p-bstr,dispidMember.l)
  GetParentFolderName(Path.p-bstr,dispidMember.l)
  GetFileName(Path.p-bstr,dispidMember.l)
  GetBaseName(Path.p-bstr,dispidMember.l)
  GetExtensionName(Path.p-bstr,dispidMember.l)
  GetAbsolutePathName(Path.p-bstr,dispidMember.l)
  GetTempName(dispidMember.l)
  DriveExists(DriveSpec.p-bstr,dispidMember.l)
  FileExists(FileSpec.p-bstr,dispidMember.l)
  FolderExists(FolderSpec.p-bstr,dispidMember.l)
  GetDrive(DriveSpec.p-bstr,dispidMember.l)
  GetFile(FilePath.p-bstr,dispidMember.l)
  GetFolder(FolderPath.p-bstr,dispidMember.l)
  GetSpecialFolder(SpecialFolder.l,dispidMember.l)
  DeleteFile(FileSpec.p-bstr,Force.w)
  DeleteFolder(FolderSpec.p-bstr,Force.w)
  MoveFile(Source.p-bstr,Destination.p-bstr)
  MoveFolder(Source.p-bstr,Destination.p-bstr)
  CopyFile(Source.p-bstr,Destination.p-bstr,OverWriteFiles.w)
  CopyFolder(Source.p-bstr,Destination.p-bstr,OverWriteFiles.w)
  CreateFolder(Path.p-bstr,dispidMember.l)
  CreateTextFile(FileName.p-bstr,Overwrite.w,Unicode.w,dispidMember.l)
  OpenTextFile(FileName.p-bstr,IOMode.l,Create.w,Format.l,dispidMember.l)
EndInterface
CompilerEndIf

; example:

Define.IFileSystem oFSO = CreateObject("Scripting.FileSystemObject")
Define.l Result

If oFSO

  oFSO\GetDriveName(GetTemporaryDirectory(), @Result)
  Debug PeekS(Result, #PB_Any, #PB_Unicode)

  oFSO\GetExtensionName(#PB_Compiler_Home + "Examples\Sources\FileSystem.pb",@Result)
  Debug PeekS(Result, #PB_Any, #PB_Unicode)

  oFSO\GetTempName(@Result)
  Debug PeekS(Result, #PB_Any, #PB_Unicode)

  ReleaseObject(oFSO)
EndIf

; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 19
; FirstLine = 6
; Folding = -
; EnableXP
; HideErrorLog